/*
 *  SoundPlayer.java
 *
 *  Copyright (c) 2004-2007  Brekeke Software, Inc. All rights reserved.
 *
 *  BREKEKE JTAPI SDK Sample Program
 */

import javax.telephony.*;
import javax.telephony.callcontrol.CallControlCall;
import javax.telephony.media.BasicMediaService;
import javax.telephony.media.ConfigSpec;
import javax.telephony.media.MediaProvider;
import javax.telephony.media.PlayerEvent;


/*** Play a specified sound file (.ul) only one time or repeatedly  ***/


public class SoundPlayer extends BasicMediaService implements Runnable {

		boolean single = false;
        CallControlCall call = null;
        volatile Thread thread;
        MediaProvider prv;
        String filename;
        Terminal tm = null;


        /// Constructors ///
        SoundPlayer(Call call) {
            super((MediaProvider)call.getProvider());
            this.tm = null;
            this.call = (CallControlCall) call;
        }

        
        SoundPlayer(Terminal tm){
            super((MediaProvider) tm.getProvider());
            this.call = null;        
            this.tm = tm;
        }

        /// Play repeatedly untill stop()///
        public void start(String filename){
           single = false;
           this.filename = filename;
           thread = new Thread(this);
           thread.start();
       }
       
        /// Play just one time ///
       public void singleplay(String filename){
           single = true;

           this.filename = filename;
           System.out.println("filename="+filename);
           thread = new Thread(this);
           thread.start();
       }
        
        
  public void run() {

      Thread thisThread = Thread.currentThread();

            
       try {
           
       		if(isBound() == false){
       			if(call != null){
       				bindToCall(ConfigSpec.basicConfig, call);
       			}
           
       			else if(tm != null){
                bindToTerminal(ConfigSpec.basicConfig, tm);
       			}
             }
                
                PlayerEvent playev = null;
                
             while(thread == thisThread)
               {
                    if(call != null || tm != null ){

                    	if(filename == null) throw new Exception("Filename is null");
                    	
                        System.out.println("play sound :"+filename);
                        playev = play(filename, 0, null, null);                        
                        
                        if(single == true) break;
                        
                  if(playev.getQualifier().equals(PlayerEvent.q_Standard))                             
                  {
                        continue;
                  }

                  else{
                      break;
                  }
                    }
                    else{
                        break;
                    }

                } 
            
            } 
       		catch (Exception ex) { 
                System.err.println(ex);
            }
        }
  
  /// Stop Playing sound ///
  public void stop(){
      if(thread!=null){
          try{
              System.out.println("isBound? "+isBound() + " this:"+this);
              if(isBound() == false){
                  if(call != null){
                      bindToCall(ConfigSpec.basicConfig, call);
                    
                 }
                 
                else if(tm != null){
                      bindToTerminal(ConfigSpec.basicConfig, tm);
                  
                 }

              }
            
              stopPlayer();

          if (isBound())
              try {
                  release(); 	    
              } catch (Exception ex) {} 
               

          }catch(Exception ex){
              ex.printStackTrace();
          }

        thread = null;
      }
  }
        
  
  
  

}
